// FunctionalProthesis.ino
// ESP32 @ IDE 1.8.12

# define inpPin 34
# define servoControlPin 12

#define TIMER_INTERRUPT_DEBUG       1
#define ISR_SERVO_DEBUG             1
#define USE_ESP32_TIMER_NO          3
#include "ESP32_ISR_Servo.h"

#define MIN_MICROS    1000  
#define MAX_MICROS    2000
#define NUM_SERVOS    1

typedef struct
{ int     servoIndex;
  uint8_t servoPin;
} 
ISR_servo_t;
ISR_servo_t ISR_servo[NUM_SERVOS] = {-1, servoControlPin};

int averages=10000;
float sigma;
long int offset=0;
int servoPosition;       // servo position in degrees
int maxPos=100;

void setup() 
{ ESP32_ISR_Servos.useTimer(USE_ESP32_TIMER_NO);  
  for (int index=0; index<NUM_SERVOS; index++)
  { ISR_servo[index].servoIndex=ESP32_ISR_Servos.setupServo(ISR_servo[index].servoPin,MIN_MICROS, MAX_MICROS);
  }

  Serial.begin(250000); 
  for (int i=1; i<averages; i++)
  { // analogPulseValue = analogRead(inpPin);
    offset += analogRead(inpPin);
  } 
  offset /= averages;
}

void loop() 
{ sigma = 0;
  for (int i=0; i< averages; i++)
    sigma += abs(analogRead(inpPin) - offset);
  servoPosition=maxPos-sigma/averages;
  Serial.println(servoPosition);
  for (int index = 0; index < NUM_SERVOS; index++)
    ESP32_ISR_Servos.setPosition(ISR_servo[index].servoIndex, (servoPosition+index*(180/NUM_SERVOS))%180 );
    delay(10);
}
