//PONG_single_OLED.ino
//ESP32 @ IDE 1.8.12
//SSD1306: SDA->IO21, SCL->IO22 

#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define W  63  //display Width 
#define H  63  //displays Height
#define bat_W 2
#define bat_H 12
#define R_BALL 3    // 1 - 3 - 7
Adafruit_SSD1306 display(128,64, &Wire, -1); //screen-width:128-high:64,no rst:-1
int y_bat = 0;
float x_ball = W/2, y_ball = H/2;
float v_ball_X = 4, v_ball_Y = 3;
int speedFactor = 30; //0:slow...100:fast

void setup() 
{ display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  display.setTextColor(WHITE);
}

void loop()
{ int control=analogRead(34);
  y_bat=map(control,0,4*1023,0,H-bat_H);
  x_ball += v_ball_X; y_ball += v_ball_Y;
  if (y_ball>=H-R_BALL-1||y_ball<=R_BALL+1) v_ball_Y*=-1;   //bounce from top-bottom
  if (x_ball>=W-R_BALL-1) v_ball_X*=-1;                     //bounce from wall
  if (x_ball>=0&&x_ball<=R_BALL&&v_ball_X<0)                //bounce from bat 
  { if (y_ball>y_bat-R_BALL&&y_ball<y_bat+bat_H) v_ball_X*=-1;
  }
  if (x_ball <= 0)            //ball missed
  { display.invertDisplay(true); delay(100);
    display.invertDisplay(false); delay(100);
    x_ball=W-R_BALL-1;
  }
  display.clearDisplay();
  display.drawRect(0,0,W,H,WHITE);                           //draw bound
  display.drawLine(0,0,0,H,BLACK);                        
  display.fillRect(0,y_bat,bat_W,bat_H,WHITE);               //draw bat
  display.fillCircle(x_ball,y_ball,R_BALL,WHITE);            //draw ball
  delay(100-speedFactor);
  display.display();
} 
