// ServoControl.ino
// ESP32 @ IDE 1.8.12

#define TIMER_INTERRUPT_DEBUG 1
#define ISR_SERVO_DEBUG 1
#define USE_ESP32_TIMER_NO 3
#include "ESP32_ISR_Servo.h"

#define MIN_MICROS      1000  
#define MAX_MICROS      2000
#define NUM_SERVOS      1
#define PIN_SERVOS      12

typedef struct
{ int servoIndex;
  uint8_t servoPin;
} 

ISR_servo_t;
ISR_servo_t ISR_servo[NUM_SERVOS]={-1,PIN_SERVOS};

void setup() 
{ ESP32_ISR_Servos.useTimer(USE_ESP32_TIMER_NO);  
  for (int index=0; index<NUM_SERVOS; index++)
  { ISR_servo[index].servoIndex=ESP32_ISR_Servos.setupServo(ISR_servo[index].servoPin, MIN_MICROS, MAX_MICROS);
  }
}

void loop() 
{ int position;      // position in degrees
  for (position=45; position<=135; position+=1) 
  { for (int index = 0; index < NUM_SERVOS; index++)
    ESP32_ISR_Servos.setPosition(ISR_servo[index].servoIndex, (position + index * (180 / NUM_SERVOS)) % 180 );
    delay(10);
  }
  
  for (position = 135; position >= 45; position -= 1) 
  { for (int index = 0; index < NUM_SERVOS; index++)
    ESP32_ISR_Servos.setPosition(ISR_servo[index].servoIndex, (position + index * (180 / NUM_SERVOS)) % 180);
    delay(10);
  }

}
